#include "stdafx.h"
#include "WinNotify.h"
#include "MainFrm.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#pragma warning(suppress: 26409 26440 26433 26477)
IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_CREATE()
  ON_WM_ACTIVATE()
  ON_WM_CLOSE()
END_MESSAGE_MAP()

std::array<UINT, 2> indicators
{
  ID_SEPARATOR,
  ID_INDICATOR_MSG,
};

#pragma warning(suppress: 26434)
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
  //Let the base class do its thing
  if (__super::OnCreate(lpCreateStruct) == -1)
    return -1;

  if (!m_wndToolBar.Create(this) ||	!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
  {
    TRACE(_T("Failed to create toolbar\n"));
    return -1;
  }

#pragma warning(suppress: 26472)
  if (!m_wndStatusBar.Create(this) || !m_wndStatusBar.SetIndicators(indicators.data(), static_cast<int>(indicators.size())))
  {
    TRACE(_T("Failed to create status bar\n"));
    return -1;
  }

  m_wndStatusBar.SetPaneInfo(0, ID_SEPARATOR, SBPS_NOBORDERS, 250);
  m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |	CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

  return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
  //Customize the window styles
  cs.style = WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZE;

  //Force the size of the main frame to just surround the formview. Note that this
  //logic is not ideal as we do not properly allow for the status bar and toolbar at
  //different DPI settings
  HDC hScreen{::GetDC(nullptr)};
  const int nXPixelsPerInch{GetDeviceCaps(hScreen, LOGPIXELSX)};
  const int nYPixelsPerInch{GetDeviceCaps(hScreen, LOGPIXELSY)};
  ::ReleaseDC(nullptr, hScreen);
  cs.cx = 380 * nXPixelsPerInch / 96;
  cs.cy = 330 * nYPixelsPerInch / 96;

  return __super::PreCreateWindow(cs);
}

#pragma warning(suppress: 26434)
void CMainFrame::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized) 
{
  //Let the base class do its thing
  __super::OnActivate(nState, pWndOther, bMinimized);

  CString sText;
#pragma warning(suppress: 26472)
  const int nNum{static_cast<int>(GetDoc()->GetNumberMessages())};
  if ((nState == WA_INACTIVE) && bMinimized && nNum)
  {
    if (nNum == 1)
      VERIFY(sText.LoadString(AFX_IDS_APP_TITLE3));
    else
    {
      CString sNum;
      sNum.Format(_T("%d"), nNum);
      AfxFormatString1(sText, AFX_IDS_APP_TITLE2, sNum);
    }
  }
  else
    VERIFY(sText.LoadString(AFX_IDS_APP_TITLE));

  SetWindowText(sText);
}

CWinNotifyDoc* CMainFrame::GetDoc()
{
  //What will be the return value from this function
  CWinNotifyDoc* pDoc{nullptr};

  POSITION posTemplate{AfxGetApp()->GetFirstDocTemplatePosition()};
  const CDocTemplate* pDocTemplate{AfxGetApp()->GetNextDocTemplate(posTemplate)};
  if (pDocTemplate != nullptr)
  {
    POSITION posDoc{pDocTemplate->GetFirstDocPosition()};
#pragma warning(suppress: 26466)
    pDoc = static_cast<CWinNotifyDoc*>(pDocTemplate->GetNextDoc(posDoc));
  }

  ASSERT(pDoc != nullptr);
  return pDoc;
}

#pragma warning(suppress: 26434)
void CMainFrame::OnClose()
{
  if (AfxMessageBox(IDP_EXIT_MSG, MB_OKCANCEL | MB_ICONQUESTION) == IDOK)
    __super::OnClose();
}
