#include "stdafx.h"
#include "resource.h"
#include "WinNotify.h"
#include "WinNotifyDoc.h"
#include "WinNotifyView.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#pragma warning(suppress: 26409 26433 26440 26477)
IMPLEMENT_DYNCREATE(CWinNotifyView, CFormView)

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CWinNotifyView, CFormView) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_CREATE()
  ON_WM_DESTROY()
  ON_WM_TIMER()
  ON_UPDATE_COMMAND_UI(ID_INDICATOR_MSG, &CWinNotifyView::OnUpdateMessage)
END_MESSAGE_MAP()

#pragma warning(suppress: 26455)
CWinNotifyView::CWinNotifyView() : CFormView{CWinNotifyView::IDD},
                                   m_nTimerID{0}
{
}

void CWinNotifyView::DoDataExchange(CDataExchange* pDX)
{
  __super::DoDataExchange(pDX);
  DDX_Text(pDX, IDC_MESSAGE, m_sMessage);
  DDX_Text(pDX, IDC_FROM, m_sFrom);
  DDX_Text(pDX, IDC_TO_DATE, m_sTimeAndTo);
}

#pragma warning(suppress: 26434)
int CWinNotifyView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
  //Let the base class do its thing
  if (__super::OnCreate(lpCreateStruct) == -1)
    return -1;

  //Create the timer to check for new mail
  m_nTimerID = SetTimer(1, 2000, nullptr);

  return 0;
}

#pragma warning(suppress: 26434)
void CWinNotifyView::OnDestroy()
{
  //Don't forget to destroy the timer
  KillTimer(m_nTimerID);
  m_nTimerID = 0;

  //Let the base class do its thing
  __super::OnDestroy();
}

#pragma warning(suppress: 26434)
void CWinNotifyView::OnTimer(UINT_PTR nIDEvent)
{
  //Check for new mail if required
  if (nIDEvent == m_nTimerID)
    GetDoc()->CheckForNewMail();
  else
    __super::OnTimer(nIDEvent);
}

void CWinNotifyView::OnUpdate(CView* /*pSender*/, LPARAM /*lHint*/, CObject* /*pHint*/)
{
  //Update the view based on the current message in the document
#pragma warning(suppress: 26429)
  auto* pDoc = GetDoc();
  ASSERT(pDoc != nullptr);
  m_sMessage = pDoc->GetCurrentMessage();
  if (pDoc->GetNumberMessages())
  {
    AfxFormatString2(m_sFrom, IDS_FROM, pDoc->GetCurrentSender(), pDoc->GetCurrentSenderMachine());
    AfxFormatString2(m_sTimeAndTo, IDS_TO, pDoc->GetCurrentTo(), pDoc->GetCurrentMessageTime());

#pragma warning(suppress: 26429)
    auto* pMainWnd = AfxGetMainWnd();
    ASSERT(pMainWnd != nullptr);
    HICON hMessageIcon = GetApp()->m_hMessageIcon;
    pMainWnd->SetIcon(hMessageIcon, FALSE);
    pMainWnd->SetIcon(hMessageIcon, TRUE);
  }
  else
  {
    VERIFY(m_sFrom.LoadString(IDS_NO_MSGS));
    m_sTimeAndTo.Empty();

#pragma warning(suppress: 26429)
    auto* pMainWnd = AfxGetMainWnd();
    ASSERT(pMainWnd != nullptr);
    HICON hNoMessageIcon = GetApp()->m_hMessageIcon;
    pMainWnd->SetIcon(hNoMessageIcon, FALSE);
    pMainWnd->SetIcon(hNoMessageIcon, TRUE);
  }
  UpdateData(FALSE);
}

CWinNotifyDoc* CWinNotifyView::GetDoc() const
{
#pragma warning(suppress: 26466)
  return static_cast<CWinNotifyDoc*>(GetDocument());
}

#pragma warning(suppress: 26429)
void CWinNotifyView::OnUpdateMessage(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26429)
  const auto* pDoc = GetDoc();
  ASSERT(pDoc != nullptr);

  //Update the status bar message string
  CString sNum1;
#pragma warning(suppress: 26472)
  sNum1.Format(_T("%d"), static_cast<int>(pDoc->GetCurrentMessageCount()));
  CString sNum2;
#pragma warning(suppress: 26472)
  sNum2.Format(_T("%d"), static_cast<int>(pDoc->GetNumberMessages()));
  CString sText;
  AfxFormatString2(sText, IDS_INDICATOR_MSG, sNum1, sNum2);
#pragma warning(suppress: 26486)
  pCmdUI->SetText(sText);
}
